typedef struct Bytes Bytes;
typedef struct URLwin URLwin;

enum
{
	STACK		= 8192,
	EVENTSIZE	= 256,
};

struct Bytes
{
	uchar *b;
	long n;
	long nalloc;
};

struct URLwin
{
	int infd;
	int type;

	char *url;
	Item *items;
	Docinfo	*docinfo;
};

extern char* url;
extern int aflag;
extern int defcharset;
extern int tflag;
extern int debug;

/* html2ms.c */
int allsame(Table *tab, int here);
void html2ms(URLwin *u, int width);

/* htmlfmt.c */
void htmlfmt(URLwin *u, int width);

/* main.c */
char *baseurl(char *url);
char *fullurl(URLwin *u, Rune *rhref);
int charset(char *s);
char *loadhtml(int fd, int width);

/* util.c */
void *emalloc(ulong n);
void *erealloc(void *p, ulong n);
char *estrdup(char *s);
char *estrstrdup(char *s, char *t);
char *eappend(char *s, char *sep, char *t);
void growbytes(Bytes *b, char *s, long ns);
char *baseurl(char *url);
